RDCode: RDCatalog::Catalog< entryType, paramType > Class Template Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Hierarchy
- Class Members

# RDCatalog::Catalog< entryType, paramType > Class Template Reference

abstract base class for a catalog object More...

`#include <Catalog.h>`

Inheritance diagram for RDCatalog::Catalog< entryType, paramType >:

List of all members.

## Public Member Functions
| Catalog ()
virtual | ~Catalog ()
virtual std::string | Serialize () const =0
| return a serialized form of the Catalog as an std::string
virtual unsigned int | addEntry (entryType *entry, bool updateFPLength=true)=0
| adds an entry to the catalog
virtual const entryType * | getEntryWithIdx (unsigned int idx) const =0
| returns a particular entry in the Catalog
virtual unsigned int | getNumEntries () const =0
| returns the number of entries
unsigned int | getFPLength () const
| returns the length of our fingerprint
void | setFPLength (unsigned int val)
| sets our fingerprint length
void | setCatalogParams (paramType *params)
| sets our parameters by copying the `params` argument
const paramType * | getCatalogParams () const
| returns a pointer to our parameters
## Protected Attributes
unsigned int | d_fpLength
| the length of our fingerprint
paramType * | dp_cParams
| our params object

## Detailed Description

### template<class entryType, class paramType>
class RDCatalog::Catalog< entryType, paramType >

abstract base class for a catalog object

Definition at line 28 of file Catalog.h.

## Constructor & Destructor Documentation

template<class entryType, class paramType>

RDCatalog::Catalog< entryType, paramType >::Catalog | ( |  | ) | `[inline]`

Definition at line 31 of file Catalog.h.

template<class entryType, class paramType>

virtual RDCatalog::Catalog< entryType, paramType >::~Catalog | ( |  | ) | `[inline, virtual]`

Definition at line 34 of file Catalog.h.

## Member Function Documentation

template<class entryType, class paramType>

virtual std::string RDCatalog::Catalog< entryType, paramType >::Serialize | ( |  | ) | const`[pure virtual]`

return a serialized form of the Catalog as an std::string

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >.

template<class entryType, class paramType>

virtual unsigned int RDCatalog::Catalog< entryType, paramType >::addEntry | ( | entryType * | entry,
|  | bool | updateFPLength = `true` |
| ) |  |  | `[pure virtual]`

adds an entry to the catalog

Parameters:

  | entry | the entry to be added
  | updateFPLength | (optional) if this is true, our internal fingerprint length will also be updated.

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >, and RDCatalog::LinearCatalog< entryType, orderType >.

template<class entryType, class paramType>

virtual const entryType* RDCatalog::Catalog< entryType, paramType >::getEntryWithIdx | ( | unsigned int | idx | ) | const`[pure virtual]`

returns a particular entry in the Catalog

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >, and RDCatalog::LinearCatalog< entryType, orderType >.

template<class entryType, class paramType>

virtual unsigned int RDCatalog::Catalog< entryType, paramType >::getNumEntries | ( |  | ) | const`[pure virtual]`

returns the number of entries

Implemented in RDCatalog::HierarchCatalog< entryType, paramType, orderType >.

template<class entryType, class paramType>

unsigned int RDCatalog::Catalog< entryType, paramType >::getFPLength | ( |  | ) | const`[inline]`

returns the length of our fingerprint

Definition at line 65 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< entryType, paramType, orderType >::addEntry(), and RDCatalog::HierarchCatalog< entryType, paramType, orderType >::toStream().

template<class entryType, class paramType>

void RDCatalog::Catalog< entryType, paramType >::setFPLength | ( | unsigned int | val | ) | `[inline]`

sets our fingerprint length

Definition at line 69 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< entryType, paramType, orderType >::addEntry(), and RDCatalog::HierarchCatalog< entryType, paramType, orderType >::initFromStream().

template<class entryType, class paramType>

void RDCatalog::Catalog< entryType, paramType >::setCatalogParams | ( | paramType * | params | ) | `[inline]`

sets our parameters by copying the `params` argument

Definition at line 73 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< entryType, paramType, orderType >::initFromStream().

template<class entryType, class paramType>

const paramType* RDCatalog::Catalog< entryType, paramType >::getCatalogParams | ( |  | ) | const`[inline]`

returns a pointer to our parameters

Definition at line 88 of file Catalog.h.

Referenced by RDCatalog::HierarchCatalog< entryType, paramType, orderType >::toStream().

## Member Data Documentation

template<class entryType, class paramType>

unsigned int RDCatalog::Catalog< entryType, paramType >::d_fpLength`[protected]`

the length of our fingerprint

Definition at line 96 of file Catalog.h.

Referenced by RDCatalog::Catalog< entryType, orderType >::getFPLength(), and RDCatalog::Catalog< entryType, orderType >::setFPLength().

template<class entryType, class paramType>

paramType* RDCatalog::Catalog< entryType, paramType >::dp_cParams`[protected]`

our params object

Definition at line 97 of file Catalog.h.

Referenced by RDCatalog::Catalog< entryType, orderType >::getCatalogParams(), RDCatalog::Catalog< entryType, orderType >::setCatalogParams(), and RDCatalog::Catalog< entryType, orderType >::~Catalog().

The documentation for this class was generated from the following file:

- Catalog.h